%global railsver %(gem list rails | grep rails | cut -d\\( -f2 | cut -d\\) -f1 | head -1 )

%{!?scl:%global pkg_name %{name}}
%{?scl:%scl_package rubygem-%{gem_name}}
%global gem_name shoulda

Summary: Making tests easy on the fingers and eyes
Name: %{?scl:%scl_prefix}rubygem-%{gem_name}
Version: 2.11.3
Release: 5%{?dist}
Group: Development/Languages
License: MIT
URL: http://thoughtbot.com/community/
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
# The following files are needed for testing, but are not part of the
# distribution. Here's how you obtain these files:
# 
# git clone git://github.com/thoughtbot/shoulda.git
# cd shoulda
# git checkout v2.11.3 # the version 
# cp tasks/shoulda.rake /path/to/SOURCES/rubygem-shoulda-tasks_shoulda.rake
# cp init.rb /path/to/SOURCES/rubygem-shoulda-init.rb
Source1:        rubygem-shoulda-tasks_shoulda.rake
Source2:        rubygem-shoulda-init.rb

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: %{?scl:%scl_prefix}ruby
Requires: %{?scl:%scl_prefix}rubygems
BuildRequires: %{?scl:%scl_prefix}rubygems
BuildRequires: %{?scl:%scl_prefix}rubygems-devel
BuildRequires: dos2unix
#Tests temporarily not executed in check
#BuildRequires: %{?scl:%scl_prefix}rubygem(cucumber)
#BuildRequires: %{?scl:%scl_prefix}rubygem(rake)
#BuildRequires: %{?scl:%scl_prefix}rubygem(rails)
#BuildRequires: %{?scl:%scl_prefix}rubygem(sqlite3)
#BuildRequires: %{?scl:%scl_prefix}rubygem(mocha)
BuildArch: noarch
Provides: %{?scl:%scl_prefix}rubygem(%{gem_name}) = %{version}

%description
Making tests easy on the fingers and eyes

%package doc
Summary:           Documentation for %{name}
Group:             Documentation
Requires:          %{name} = %{version}-%{release}

%description doc
Documentation for %{name}.



%prep

%build

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{gem_dir}
%{?scl:scl enable %scl "}
gem install --local --install-dir %{buildroot}%{gem_dir} \
            --force --rdoc %{SOURCE0}
%{?scl:"}

# Change from /usr/bin/ruby to /usr/bin/env ruby
find %{buildroot} -type f | \
  xargs sed -i -e 's"^#!/usr/bin/ruby"#!/usr/bin/env ruby"'

mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gem_dir}/bin/* %{buildroot}/%{_bindir}
rmdir %{buildroot}%{gem_dir}/bin
find %{buildroot}%{gem_instdir}/bin -type f | xargs chmod a+x

# Notified upstream of lack of ability to run tests after running gem install 
#  on Sep 03, 2010.  Not holding my breath.

# This task is not part of the distribution but is required for rake test in %%check
mkdir -p %{buildroot}%{gem_instdir}/tasks
cp -a -p %{SOURCE1} %{buildroot}%{gem_instdir}/tasks/%{gem_name}.rake
# This is also not part of dist gem, but needed for tests
cp -a -p %{SOURCE2} %{buildroot}%{gem_instdir}/init.rb
# This is also not part of dist gem, but needed for tests
cp -a -p %{buildroot}/%{gem_dir}/specifications/* %{buildroot}%{gem_instdir}/shoulda.gemspec

# environment.rb set to use a static Rails version -- it's not pretty, but it works
echo 'RAILS_GEM_VERSION="%{railsver}" '  >  %{buildroot}%{gem_instdir}/test/rails2_root/config/environment.tmp.rb
cat %{buildroot}%{gem_instdir}/test/rails2_root/config/environment.rb >> %{buildroot}%{gem_instdir}/test/rails2_root/config/environment.tmp.rb
mv -f  %{buildroot}%{gem_instdir}/test/rails2_root/config/environment.tmp.rb %{buildroot}%{gem_instdir}/test/rails2_root/config/environment.rb

# Fix end-of-line encoding
dos2unix %{buildroot}/%{gem_instdir}/MIT-LICENSE

# clean yardoc leftovers
rm -rf %{buildroot}/%{gem_instdir}/.yardoc



%clean
rm -rf %{buildroot}

%check 
cd %{buildroot}%{gem_instdir}
#Tests temporarily not executed in check
#rake test

%files
%defattr(-, root, root, -)
%{_bindir}/convert_to_should_syntax
%dir %{gem_instdir}
%doc %{gem_instdir}/README.rdoc
%doc %{gem_instdir}/MIT-LICENSE
%{gem_dir}/cache/%{gem_name}-%{version}.gem
%{gem_dir}/specifications/%{gem_name}-%{version}.gemspec
%{gem_instdir}/lib
%{gem_instdir}/bin
%{gem_instdir}/rails

%files doc
%defattr(-, root, root, -)
%{gem_instdir}/tasks
%{gem_instdir}/init.rb
%{gem_instdir}/*.gemspec
%{gem_dir}/doc/%{gem_name}-%{version}
%{gem_instdir}/CONTRIBUTION_GUIDELINES.rdoc
%{gem_instdir}/test
%{gem_instdir}/Rakefile



%changelog
* Wed Jun 13 2012 Troy Dawson <tdawson@redhat.com> - 2.11.3-5
- Changed spec file to work with scl
- Rebuilt for scl

* Thu Nov 17 2011 Mike Orazi <morazi@redhat.com> - 2.11.3-4
- Proxying changes for jeckersb
- Comment out tests
- Clean up yardoc
- Fix sqlite3 

* Thu Nov 17 2011 Steve Linabery <slinaber@redhat.com> - 2.11.3-3
- Change BuildRequires(check) to BuildRequires

* Wed Sep 01 2010 Michael Stahnke <stahnma@fedoraproject.org> - 2.11.3-1
- New version
- Fix many broken tests 
- Split into -doc package

* Sat Jan  9 2010 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 2.10.2-2
- Fix BuildRequires
- First package
